package cd.casic.ci.common.pipeline.option;

import cd.casic.ci.common.pipeline.NameAndValue;
import cd.casic.ci.common.pipeline.enums.DependOnType;
import cd.casic.ci.common.pipeline.enums.JobRunCondition;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;

import java.util.List;
import java.util.Map;

/**
 * @Author：mianbin
 * @Package：cd.casic.ci.common.pipeline.option
 * @Project：ops-pro
 * @name：JobControlOption
 * @Date：2025/03/25 17:59
 * @Filename：JobControlOption
 * @description：Todo
 */
@Data
@Schema(title = "job流程控制模型")
public class JobControlOption {
    @Schema(title = "是否启用Job", required = false)
    private Boolean enable = true; // 是否启用Job

    @Schema(title = "Job准备环境的超时时间 分钟Minutes", required = false)
    private Integer prepareTimeout; // Job准备环境的超时时间 分钟Minutes

    @Schema(title = "Job执行的超时时间 分钟Minutes", required = false)
    private Integer timeout = 900; // Job执行的超时时间 分钟Minutes

    @Schema(title = "新的Job执行的超时时间，支持变量 分钟Minutes，出错则取timeout的值", required = false)
    private String timeoutVar; // Job执行的超时时间 分钟Minutes

    @Schema(title = "运行条件", required = false)
    private JobRunCondition runCondition = JobRunCondition.STAGE_RUNNING; // 运行条件

    @Schema(title = "自定义变量", required = false)
    private List<NameAndValue> customVariables = List.of(); // 自定义变量

    @Schema(title = "自定义条件", required = false)
    private String customCondition; // 自定义条件

    @Schema(title = "job依赖", required = false)
    private DependOnType dependOnType; // job依赖

    @Schema(title = "需要过滤不存在的job，定义为var类型", required = false)
    private List<String> dependOnId; // 需要过滤不存在的job，定义为var类型

    @Schema(title = "job依赖名称", required = false)
    private String dependOnName;

    @Schema(title = "containerId与jobId映射，depend on运行时使用的是containerId", required = false)
    private Map<String, String> dependOnContainerId2JobIds; // containerId与jobId映射，depend on运行时使用的是containerId

    @Schema(title = "是否失败继续", required = false)
    private Boolean continueWhenFailed = false; // 失败继续

    @Schema(title = "第三方构建机集群-单节点并发限制")
    private Integer singleNodeConcurrency;

    @Schema(title = "第三方构建机集群-所有节点并发限制")
    private Integer allNodeConcurrency;
}
