package cd.casic.ci.common.pipeline.pojo.element.agent;

import cd.casic.ci.common.pipeline.enums.CodePullStrategy;
import cd.casic.ci.common.pipeline.enums.SVNVersion;
import cd.casic.ci.common.pipeline.enums.SvnDepth;
import cd.casic.ci.common.pipeline.pojo.element.Element;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * @Author：mianbin
 * @Package：cd.casic.ci.common.pipeline.pojo.element.agent
 * @Project：ops-pro
 * @name：CodeSvnElement
 * @Date：2025/03/26 16:36
 * @Filename：CodeSvnElement
 * @description：Todo
 */
@Data
@NoArgsConstructor
@Schema(title = "拉取SVN仓库代码", description = CodeSvnElement.classType)
public class CodeSvnElement extends Element {
    public static final String classType = "CODE_SVN";
    public static final String REPO_HASH_ID = "repositoryHashId";
    public static final String REPO_NAME = "repositoryName";
    public static final String REPO_TYPE = "repositoryType";
    public static final String BRANCH_NAME = "branchName";
    public static final String REVISION = "revision";
    public static final String STRATEGY = "strategy";
    public static final String PATH = "path";
    public static final String enableSubmodule = "enableSubmodule";
    public static final String enableVirtualMergeBranch = "enableVirtualMergeBranch";
    public static final String specifyRevision = "specifyRevision";
    public static final String svnDepth = "svnDepth";
    public static final String svnPath = "svnPath";
    public static final String svnVersion = "svnVersion";

    @Schema(title = "任务名称", required = true)
    private String name = "";
    @Schema(title = "id", required = false)
    private String id;
    @Schema(title = "状态", required = false)
    private String status;
    @Schema(title = "代码库哈希ID", required = true)
    private String repositoryHashId;
    @Schema(title = "revision 用于强制指定commitId", required = false)
    private String revision;
    @Schema(title = "checkout 策略", required = false)
    private CodePullStrategy strategy = CodePullStrategy.INCREMENT_UPDATE;
    @Schema(title = "代码存放路径", required = false)
    private String path;
    @Schema(title = "启动Submodule", required = false)
    private Boolean enableSubmodule = true;
    @Schema(title = "指定版本号", required = false)
    private Boolean specifyRevision = false;
    @Schema(title = "拉取仓库深度", required = false)
    private SvnDepth svnDepth = SvnDepth.infinity;
    @Schema(title = "SVN相对路径", required = false)
    private String svnPath;
    @Schema(title = "SVN的版本", required = false)
    private SVNVersion svnVersion;
    @Schema(title = "新版的svn原子的类型")
    private RepositoryType repositoryType;
    @Schema(title = "新版的svn代码库名")
    private String repositoryName;

    @Override
    public String getClassType() {
        return classType;
    }
}
