package cd.casic.ci.common.pipeline.utils;

import com.alibaba.fastjson.JSONObject;

import java.util.HashMap;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * @Author：mianbin
 * @Package：cd.casic.ci.common.pipeline.utils
 * @Project：ops-pro
 * @name：TransferUtil
 * @Date：2025/03/26 16:09
 * @Filename：TransferUtil
 * @description：Todo
 */
public class TransferUtil {
    public static Map<String, Object> simplifyParams(JSONObject defaultValue, Map<String, Object> input) {
        return input.entrySet().stream()
                .filter(entry -> {
                    var inputValue = entry.getValue();
                    if (defaultValue.containsKey(entry.getKey())) {
                        return !new JSONObject(entry.getKey(), defaultValue.get(entry.getKey())).similar(new JSONObject(entry.getKey(), inputValue));
                    }
                    return true;
                })
                .collect(Collectors.toMap(Map.Entry::getKey, Map.Entry::getValue));
    }

    public static Map<String, Object> mixParams(JSONObject defaultValue, Map<String, Object> input) {
        var out = input != null ? new HashMap<>(input) : new HashMap<>();
        if (defaultValue != null) {
            defaultValue.toMap().forEach((k, v) -> out.putIfAbsent(k, v));
        }
        return out;
    }
}
