package cd.casic.ci.process.api.process.pojo.setting;

import com.google.common.collect.Lists;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;
import lombok.val;

import java.util.LinkedList;
import java.util.List;
import java.util.concurrent.CopyOnWriteArrayList;

/**
 * @Author：mianbin
 * @Package：cd.casic.ci.process.api.process.pojo.setting
 * @Project：ops-pro
 * @name：SubscriptionResponse
 * @Date：2025/03/24 20:25
 * @Filename：SubscriptionResponse
 * @description：Todo
 */
@Data
@Schema(title = "设置-订阅消息")
public class SubscriptionResponse {
    @Schema(title = "通知人员", required = false)
    private String users = "";
    @Schema(title = "通知方式(email, rtx)", required = true)
    private List<PipelineSubscriptionType> types = new CopyOnWriteArrayList<PipelineSubscriptionType>();
    @Schema(title = "分组id", required = false)
    private List<String> groups = List.of();
    @Schema(title = "通知内容带上流水线详情连接", required = false)
    private Boolean detailFlag = false;
    @Schema(title = "自定义通知内容", required = false)
    private String content = "";

}
